/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* Shuts down the program NOW! */

#include "ftpd.h"

void ftpd_shutdown(void)
{
#ifdef DEBUG
	printf("[ftpd_shutdown]\n");
#endif
	if (config != NULL)
	{
		if (config->logfile)
			freewrapper(config->logfile);
		if (config->accessdir)
			freewrapper(config->accessdir);
		if (config->iplist)
			freewrapper(config->iplist);
		if (config->netmasklist)
			freewrapper(config->netmasklist);
		if (config->listenfds)
			freewrapper(config->listenfds);
		if (config->listenport)
			freewrapper(config->listenport);
		if (config->prelogondump)
			freewrapper(config->prelogondump);
		if (config->email)
			freewrapper(config->email);
		if (config->listenips)
			freewrapper(config->listenips);
		if (config->pidfile)
			freewrapper(config->pidfile);
		if (config->username)
			freewrapper(config->username);
		log_shutdown();
		freewrapper(config);		
	}
}
